#include <string.h>

#include "MergeSort.h"

void CopyArray(ArrayOfStrings sourceArray, ArrayOfStrings targetArray, int lowerIndex, int upperIndex)
{
	int		index;

	for (index=lowerIndex; index<=upperIndex; index++) {
		strcpy(targetArray[index], sourceArray[index]);
	}
}


#define COPYLOWER	{	strcpy(targetArray[index], lowerArrayTemp[lowerIndex]);	\
						lowerIndex++; }
#define COPYUPPER	{	strcpy(targetArray[index], upperArrayTemp[upperIndex]);	\
						upperIndex++; }

void MergeSort (ArrayOfStrings targetArray, int lowerFence, int upperFence)
{

	int				middle;
	ArrayOfStrings	lowerArrayTemp;
	ArrayOfStrings	upperArrayTemp;

	int				index;			/* next target array position	*/
	int				lowerIndex;		/* next element of lower array	*/
	int				upperIndex;		/* next element of upper array	*/

	int				compareResult;

	/* base case - a single element is sorted */

	if (lowerFence >= upperFence) return;

	/* otherwise...									*/
	/* (A) Divide the unsorted portion into half	*/

	middle = (lowerFence + upperFence) / 2;

	CopyArray(targetArray, lowerArrayTemp, lowerFence, middle);
	CopyArray(targetArray, upperArrayTemp, middle+1, upperFence);

	/* (B) Sort each half							*/

	MergeSort(lowerArrayTemp, lowerFence, middle);
	MergeSort(upperArrayTemp, middle+1, upperFence);

	/* (C) Now merge the two halves					*/

	lowerIndex = lowerFence;
	upperIndex = middle+1;
	index = lowerFence;

	while (lowerIndex<=middle || upperIndex<=upperFence) {
		if (lowerIndex>middle) {
			COPYUPPER
		} else if (upperIndex>upperFence) {
			COPYLOWER
		} else {
			compareResult = strcmp(lowerArrayTemp[lowerIndex], upperArrayTemp[upperIndex]);
			switch (compareResult) {
				case -1:	COPYLOWER
							break;
				case 0:		COPYLOWER	/* arbitrary choice of the two */
							break;
				case 1:		COPYUPPER
							break;
			}
		}
		index++;
	
	}

}